\ commands.fs -- most of the command repertoire for PROG -- 29Aug13 rjn
\ 
] here ( *)
\ 
0 [if] \ -----------------[ key with timeout ]---------------------------------
\ 
\ use code in bootloader?
\
cpuHere constant #nokey 1 cpuAllot

\ -: key  ( - c)   begin 0 .SCON until. 0 .SCON clr SBUF #@ ;
-: /key  0 # #nokey #! ;

\ ok for 9600 baud
: key?  ( - c ?)  \ key with char timeout -- true=key ok, false=exit rcv loop   
   0 .SCON if. [ 0 .SCON clr ] SBUF #@  $ff # ; then 
10 # us  [ #nokey inc ]  #nokey #@  0=if 0 # ; then drop key?  ;
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ -----[ detect Target ]
\ 
[ 
: (?)  ( -- ?)   [char] ? emit-s  isend= ;
: (?target)  (?) 0= if cr ." NO TARGET DETECTED" abort" !" then ;
: ?target  (?target) cr ." Target detected"  100 ms ;
]
\ : (?)  c2ck-in  1 # ms   c2ck if. $ff # (emit) c2ck-out ; then $00 # (emit) c2ck-out ;
-: (?)  c2ck-in  ( 1 # ms) nop  c2ck if. $ff # ; then $00 # ;
: ?  (?) (emit) c2ck-out nop nop ;
\ 
[ \ ==> gforth
\  
: (.e)  ( -- n)   [char] . emit-s  [char] e emit-s  isend= ;  \ get # errors 
: .e   (.e)  ." Target errors=" h.$ ;
] \ ==> myforth
\ 
: .e  @terr (emit) ;
\ 
\ -----[ n - set number of chars to transfer, dnum ]
[ 
\ read number of bytes, dnum, from IPP, result on stack
: (.n)  ( -- n)      [char] . emit-s  [char] n emit-s  isend= ;
: .n  ( --)   (.n) ." num=" h.$  cr ;

: (n)  ( n --)  \ blindly set number of Target bytes
   depth 0= abort" no number on stack!"  
   [char] n emit-s  isend  h.-s ; 
\ : n  ( n --)  (n)  ( .n) ;   \ set and display number of Target bytes

: (l)  ( -- n)   [char] l emit-s  isend= ;
: l  ( -- n)  (l)  ."  dlen=" h.$ ; \ show IPP buffer length

]
: .n  dnum #@ (emit) ;
: n  $  dnum #!  ;

: l  dlen #@ (emit) ;
\ 
[ \ ==> gforth
\ 
\ for C2 commands such as block-read, block-write, you must issue
\ the "q" command and wait  (no init for subsequent ops)
\ note: /pi takes ~ 30 ms (see C2.fs) -- set to 50 for Host end
: q  [char] q emit-s  isend  50 ms  ;  \ q is just an unused single-char cmd

: (xx)  [char] x emit-s  isend  $ff 0 do key-s !ibuf+ loop ;
\ (x) transfers bytes directly from the Target
: (x)  ( n --)   dup (n)  [char] x emit-s  isend  0 do key-s !ibuf+ loop  ; 
: x   #dbuf (x) ;

] \ ==> myforth
\ 
: q  /pi  ;

\ extract directly from Target, dbuf & dlen are not affected
: x   /terr  direct-read  @terr 0=if drop dnum #@ +tadr ; then drop  ;
\ 
\ -----[ adr - set target programming adr in HEX ]
\ 
[ \ ==> gforth
\ 
: send-adr  [char] a emit-s  [char] d emit-s  [char] r emit-s ;

: (.adr)  ( -- n)   \ get Target adr  
   [char] . emit-s  send-adr isend  key-s key-s swap 256 * +  ;
: .adr  (.adr)  ." adr=" dh.$ ;  \ display Target adr

: (adr)  ( adr -- )    
   depth 0= abort" no Target adr on stack!"
   dup chip-#read > abort" adr out of range!" \ 07Aug13 rjn
   send-adr isend  dh.-s  ; 
: adr  (adr) .adr ;
\ 
] \ ==> myforth
\ 
: .adr   @tadr (emit) (emit) ;  \ display Target adr
: adr  $$  !tadr  ;  \ set Target adr
\ 
\ -----[ e - erase chip ]
\ 
[ 
: e   [char] e emit-s  isend=  ?dup 0= if   ." Target erased!" 
                                     else . ."  erase errors!" then cr ; 
]
\ 
: e  /terr (e)  .e  ;
\   
0 [if] \ -----[ b, s, z - send bytes from chip buffer to IPP, Target ]---------  
\ 
1. Assumes read-chip.bin has read chip.bin into the bin-buf buffer.  
2. FYI: bin-#read is number of bytes read into chip.bin buffer.
3. IPP accepts the number of bytes contained in its dnum variable.
     To set this, use the n command.
4. "b" (block) sends af full buffer of bytes, #dbuf.
5. "z" (zap) sends to the buffer and then programs the Target.
6. Each block write to the IPP automatically advances the current target address 
   pointer, tadr, a 16-bit value.
\   
[then] \ ----------------------------------------------------------------------
\ 
[ \ ==> gforth
0 [if] \ -----[ display only, don't send to ibuf ]
\ 
: /p  [char] / emit-s  [char] p emit-s isend ;
: @x  [char] @ emit-s  [char] x emit-s  isend= ;
: .x  /p  16 0 do  cr 16 0 do @x h. loop  loop ;
\ 
[then] \ ------------------------------------------

\ send n bytes from cbuf (at current offset) to IPP buffer
: s  ( n -- n')  \ send n bytes, result is # bytes written
   depth 0= abort" s command: no send count!"
   dup (n)
   [char] s emit-s  isend  \ set IPP for read
   dup 0 do @cbuf+ emit-s loop  key-s 
   = if [char] . else [char] x  then emit ;
\ 
\ Send one block to IPP buffer.
: b  ( --)   #dbuf s  ;

] \ ==> myforth
\ 
\ -----[ s - store dnum bytes in IPP buffer ]
\ 
: /p  0 ## p!  ;
: s   0 ## p!  /dlen  dnum #@  7 #for key !x+ dlen+ 7 #next  l ;
\ 
0 [if] \ ----------[ t - transfer n bytes ipp buffer to Target ]---------------  
\  
1. Writes dlen bytes from the IPP buffer to the Target starting at  
     the current Target address, tadr.  The address pointer, tadr, is 
     advanced by dnum bytes if there are no errors.
2. Assumes the the target bytes are already $ff from an erase.
3. The result is transferred as a single byte back to the Host.  The byte
   is the number of errors..
\   
[then] \ ----------------------------------------------------------------------
\ 
[ \ ==> gforth
\ 
\ write dlen bytes from IPP buffer to target at its current address pointer, tadr.
\ A "t" command is typically issued after an "s" command 

: t   [char] t emit-s  isend= ;
: m   [char] m emit-s  isend  ; \ move to next block
\ 
] \ ==> myforth
\ 
: m  ( #bs #)  dnum #@  +tadr ;

: t   /terr  block-write  @terr (emit) ;

\ 
\ -----[ p, d - program Target ]
\ 
[ \ ==> gforth
\ 
: /pd  $0000 (adr)  /cbuf>  e  q  ;

\ : .both  ( n --)   dup .  [char] ( emit (dh.$) [char] ) emit ;
: .programmed  cr  cbuf> @  .both  ." Target bytes programmed" ;

$ff value #bs  \ block size ($ff max)

0 [if] \ -------------------------[ d notes ]----------------------------------
\ 
1. ~34 seconds at 9600 baud
2. t used in the programming loop provides a error count, indicating
   that the Target block has been programmed.  Gforth waits for this so
   that it doesn't issue another block programming cammand until the
   Target is finished programming the current block.
\ 
[then] \ ----------------------------------------------------------------------
\ 
: ?!  ( n --)   if [char] ! emit then ;

: data?  ( n -- ?)   \ true if non-$ff byte
   to #bs
   cbuf> @
      0  #bs 0 do @cbuf+ $ff = not if drop -1 then loop
   swap cbuf> ! ;

: cskip  cbuf> @ #bs + cbuf> ! ;

: dd  ( n --)   data? if b t ?! else cskip [char] _ emit  then m ;

: d  \ program Target using IPP buffer
   chip-#read  0= abort" read chip before programming"
   cr .time ."  Programming (buffered):" cr
   #dbuf (n)  /pd  
   chip-#read  #dbuf /mod  0 do #dbuf dd  loop \ 28Aug13 rjn
   ?dup if dd then  .programmed  ;  

: (pp)   ( --)   
   [char] p dup emit-s emit-s  isend
   #bs  0 do @cbuf+ emit-s loop  
   key-s 0= if [char] . else [char] x then emit ;  

: pp  ( n --)   data? if (pp) else cskip [char] _ emit then m ;

\ note: ~32 seconds at 9600 baud
: p  \ download to Target directly from chip buffer
   chip-#read  0= abort" read target.bin before programming"
      cr .time ."  Programming (direct): "
      $ff to #bs  #bs  (n)  /pd
      chip-#read  #bs  /mod  0 do #bs pp loop   \ 07Aug13 rjn
      ?dup if dup (n) pp then  .programmed  ;   
\ 
] \ ==> myforth
\ 
: pp  ( -- n)  /terr  direct-write  @terr (emit) ;
\ 
\ 
0 [if] \ -------[ r - receive bytes from IPP buffer to image-buffer ]-----------
\
1. The s command returns the number of bytes stored in the IPP buffer,
    dbuf.
2. The r command uses this count to receive bytes from the IPP, putting them
    in the image buffer at the current image buffer pointer, ibuf>, advancing
    ibuf> as characters are added.
3. Use the "back" buffer dump (idump-) to verify the operation of r.  It backs
    up the current image buffer offset by #dbuf before doing a dump.  This does
    not affect the image buffer pointer, ibuf> .
4. Use idump to dump starting at the current pointer.  Use idump> to set the
     pointer before doing a dump.  These do not affect the buffer pointer, ibuf>.
\   
[then] \ ----------------------------------------------------------------------
\
[ \ ==> gforth
\
\ receive dlen bytes from IPP buffer, store them in the image buffer

: (r)  ( n --)  [char] r emit-s  isend  0 do key-s !ibuf+ loop ;
: lr   (l) (r) ;

: r  ( --)  \ receive dlen bytes, display in image dump    
   (l) dup 0= abort" IPP buffer empty!"
   dup (r)  dup .both ." bytes received" ibuf> @ swap - 0 max cr idump ;

] \ ==> myforth
\ 
: r   0 ## p!  dlen #@  7 #for @x+ (emit) 7 #next ;  \ send dlen bytes to host
\ 
0 [if] \ -----[ g,f - get, fetch Target to image buffer, buffered & not ]------
\
1. The prgrom interface must first be initialized with "q'. 
\   
[then] \ ----------------------------------------------------------------------
\ 
[ \ ==> gforth
\ 
: /gf   $0000 (adr)  /ibuf  q ;

: .transfered  cr ibuf> @  .both  ." bytes transfered to image buffer" ;

\ note: ~10 seconds at 9600 baud
: g   \ get - fill Host image buffer directly from Target (no buffering)
  cr .time ."  Getting Target Bytes: " cr
  $ff (n) /gf  \ direct transfer from Target
  chip-#read  $ff  /mod  0 do (xx) [char] . emit loop   \ 07Aug13 rjn
  ?dup if (x) then [char] . emit  .transfered  ( save-image) ;

: save-target  g  save-image ;
\ 
] \ ==> myforth
\ 
\ -----[ i - display chip info such as ID, rev., adr, len ]
\ 
[ 
: v   [char] v emit-s  isend  11 0 do key-s emit loop ;
]
\ 
: v   ver$  ;

[ 
\ per Table 10 in SL AN127 (only 300 and 36x verified)
\ only chips with a FPDAT address of $b4 are detected
: .id  [char] . emit-s  [char] i emit-s  [char] d emit-s  $13 emit-s  
   key-s  ."  ID=" dup h.$ ." chip="
   dup $04 = if ." 30x"   drop 0 then 
   dup $08 = if ." 31x"   drop 0 then
   dup $09 = if ." 32x"   drop 0 then
   dup $0d = if ." 326/7" drop 0 then
   dup $0a = if ." 33x"   drop 0 then
   dup $14 = if ." 336/7" drop 0 then
   dup $0b = if ." 35x"   drop 0 then
   dup $12 = if ." 36x"   drop 0 then
   dup $2b = if ." 39/7x" drop 0 then
   dup $0c = if ." 41x"   drop 0 then
   dup $1c = if ." 50/1x" drop 0 then
   dup $11 = if ." 52/3x" drop 0 then 
   dup $21 = if ." 54x"   drop 0 then
   dup $22 = if ." 55-7x" drop 0 then
   dup $20 = if ." 58/9x" drop 0 then
   dup $1e = if ." 70/1x" drop 0 then
   dup $23 = if ." 80-3x" drop 0 then
   dup $30 = if ." 85x"   drop 0 then
   dup $1f = if ." 90/1x" drop 0 then
   dup $16 = if ." 92/3x" drop 0 then
   dup $2a = if ." 96x"   drop 0 then
   dup $25 = if ." 99x"   drop 0 then
   dup $10 = if ." T60x"  drop 0 then
   dup $1b = if ." T606"  drop 0 then
   dup $13 = if ." T61x"  drop 0 then
   dup $17 = if ." T63x"  drop 0 then
         0 > if ." ???"          then  space ; 
]
: .id   did (emit) ;

[ : .r  [char] . emit-s  [char] r emit-s  isend  
   key-s  ." rev=" . ; ]
: .r   rid (emit) ;

[ 
: i  ( cr  v)  ( ?target)  ( ."   Target:")  .id  .r ; 
: ix l .adr .n ;
]
\ 
\ -----[ rst - reset ]
\ 
[ \ ==> gforth 
: rst  [char] r emit-s  [char] s emit-s  [char] t emit-s  isend 
    ( 11 0 do key-s emit loop) ; 
\ 
\ -----[ tr - Reset Target ]
\ 
: tr  [char] t emit-s  [char] r emit-s  isend  ."  Target reset!" ;
]
: tr  c2-reset  ;
\ 
\ -----[ te - enable Target ]
\ 
[ 
\ enables Target serial output via MUX
: tm  [char] t emit-s  [char] e emit-s  isend ;
: im  [char] i emit-s  [char] e emit-s  isend ;
]
: tm   [ 6 .P0 clr ]  ;
: im   [ 6 .P0 set ]  ;
\ 
\ 
1 [if] \ -----[ h - help ]
[ \ ==> gforth
: h  \ display ipp commands
   cr ." ================== Interpose Processor Commands =================="
   cr
   cr ." adr  - Enter Target address (in HEX)"
   cr ." b    - Write one block to IPP buffer (dbuf)"
   cr ." d    - Download chars from Host, program Target (buffered)"
   cr ." e    - Erase chip (wait ~ 1 sec for a response)"
   cr ." g    - Get Target image and put in image buffer (direct from Target)"
   cr ." h    - Show help screen (this screen)"
   cr ." i    - Show IPP/Target information"
   cr ." im   - Enable the IPP talk to Host via MUX (forces IPP P0.6 high)"
   cr ." l    - Length: read number of bytes in IPP buffer ( -- dlen)"
   cr ." n    - Set number of chars to download (dnum)"
   cr ." p    - Program Target directly from Host (not buffered)"
   cr ." rst  - Request an IPP reset (wait ~ 1 sec for a response)"
   cr ." r    - Receive n bytes from IPP buffer to image buffer( n --)"
   cr ." s    - Send n bytes from image buffer to IPP buffer ( n -- n')"
   cr ." tr   - Reset Target"
   cr ." t    - Transfer IPP buffer to Target (uses dnum, tadr)"
   cr ." tm   - Enable Target serial via MUX (forces IPP P0.6 low)"
   cr ." u    - Show Programmer Utilities menu"
   cr ." v    - Show Programmer version"
   cr ." ix   - Show extended IPP info such as dlen, dnum & tadr"
   cr
 ;
\ 
\ -----[ u - utilities menu ]
\ 
: u  \ utilities menu
   cr ." ================= IPP Programmer Utilities Menu ===================="
   cr
   cr ." .adr       - Show Target address pointer (set with adr)"
   cr ." cdumpa     - Dump chip buffer at current offset (cbuf>)"
   cr ." cdump      - Dump chip buffer starting at address on stack ( a --)"
   cr ."            -   If stack is empty, dump starting at 0 offset"
   cr ." cdump-     - Dump chip buffer starting 64 bytes back from offset"
   cr ." /cbuf      - Initalize chip buffer"
   cr ." .chip-size - Show chip.bin size (if loaded into chip buffer)"
   cr ." diff       - Compare chip and image buffers"
   cr ." idumpa     - Dump image buffer at current offset (ibuf>)"
   cr ." idump      - Dump image buffer starting at address on stack (a --)"
   cr ."            -   If stack is empty, dump starting at 0 offset"
   cr ." idump-     - Dump image buffer starting 64 bytes back from offset"
   cr ." .ibuf>     - Show current image buffer offset"
   cr ." /ibuf      - Initalize image buffer"
   cr ." .id        - Show Target chip's ID (read from chip)"
   cr ." in         - configure IPP's c2d as input"
   cr ." .n         - Show current download count (set with n)"
   cr ." .r         - Show Target chip's revision number (read from chip)"
   cr ." ~          - Toggles P1.1, LED DS2 -- it is illuminated at reset"
   cr ." read-chip  - Read chip.bin to chip buffer (normally done at startup)"
   cr ." save-image - Save image buffer to target.img file"
   cr
 ;

\ 
] \ ==> myforth
\ 
[then] \ ----------------------------------------------------------------------

\ 
here [ swap -  ( -- n)
cs? [if] cr .( commands.fs        ) . .( bytes) [else] drop [then] 
\ 
\ 
0 [if] \ -----------------------[ revisions ]-----------------------------------
\ 
Date	   By  Comment
=======	=== ===================================================================
14Aug13  rjn production version.  Block skipping, target reset, misc. cleanup
10Aug13  rjn changed for conditional compilation.
06Aug13  rjn changes to ID for 361 chip.
23Jul13  rjn all cmds working with new single-char response protocol
21Jul13  rjn changed version, fixed duplicate entry on help.
28Dec12  rjn initial version, cloned from AGEN Dev.
\ 
[then] \ ----------------------------------------------------------------------


