\ configuration.fs -- save/restore settings to flash  -- 24Jan13 rjn
\
] ( target forth)  here  ( start marker)
\
1 [if] \ ------------------------[ hold register ]-----------------------------
\ 
\ ----- hold 
config-block constant #f-hold
-: save-hold   #f-hold ##p!  hold #  fwrite-quad ;
-: @f-hold  ( - lsb ... msb)   #f-hold ##p!  fread-quad ;
-: /hf  @f-hold  hold # !quad ;  \ init hold from flash
\
\ ----- hold defaults
\ -: hold-def ; \ label for looking at defaults
here constant hold-default
$37 , $86 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %h  hold-default ##p!  fread-quad  hold # !quad ; \ init hold from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ --------------------[ hold phase register ]--------------- 23Jan13 rjn
\ 
\ ----- phold
[ config-block 4 + ] constant #f-phold
-: save-phold   #f-phold ##p!  phold #@  !f ;
\ -: @f-phold  ( - n)   #f-phold ##p!  @f ;
-: /ph ( @f-phold)  #f-phold ##p!  @f  phold #! ;  \ init phold from flash
\
\ ----- afreq defaults
\ -: phold-def ;
here constant phold-default
$00 , 
-: %ph  phold-default ##p!  @f phold #! ; \ init phold from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ afreq register ]-----------------------------
\ 
\ ----- afreq 
[ config-block 5 + ] constant #f-afreq
-: save-afreq   #f-afreq ##p!  afreq #  fwrite-quad ;
\ -: @f-afreq  ( - lsb ... msb)   #f-afreq ##p!  fread-quad ;
-: /af  ( @f-afreq)  #f-afreq ##p!  fread-quad  afreq # !quad ;  \ init afreq from flash
\
\ ----- afreq defaults
\ -: afreq-def ;
here constant afreq-default
$37 , $86 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %af  afreq-default ##p!  fread-quad  afreq #  !quad ; \ init afreq from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ ----------------------[ aphase register ]-----------------------------
\ 
\ ----- aphase
[ config-block 9 + ] constant #f-aphase
-: save-aphase   #f-aphase ##p!  aphase #@  !f ;
\ -: @f-aphase  ( - n)   #f-aphase ##p!  @f ;
-: /ap  ( @f-aphase) #f-aphase ##p!  @f  aphase #! ;  \ init aphase from flash
\
\ ----- aphase defaults
\ -: aphase-def ;
here constant aphase-default
$00 , 
-: %ap  aphase-default ##p!  @f aphase #! ; \ init aphase from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ bfreq register ]-----------------------------
\ 
\ ----- bfreq 
[ config-block 10 + ] constant #f-bfreq
-: save-bfreq   #f-bfreq ##p!  bfreq #  fwrite-quad ;
\ -: @f-bfreq  ( - lsb ... msb)   #f-bfreq ##p!  fread-quad ;
-: /bf   ( @f-bfreq)  #f-bfreq ##p!  fread-quad  bfreq # !quad ;  \ init bfreq from flash
\
\ ----- bfreq defaults
\ -: bfreq-def ;
here constant bfreq-default
$37 , $86 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %bf  bfreq-default ##p!  fread-quad  bfreq #  !quad ; \ init afreq from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ ----------------------[ bphase register ]-----------------------------
\ 
\ ----- bphase
[ config-block 14 + ] constant #f-bphase
-: save-bphase   #f-bphase ##p!  bphase #@  !f ;
\ -: @f-bphase  ( - n)   #f-bphase ##p!  @f ;
-: /bp  ( @f-bphase) #f-bphase ##p!  @f  bphase #! ;  \ init bphase from flash
\
\ ----- bphase defaults
\ -: bphase-def ;
here constant bphase-default
$00 , 
-: %bp  bphase-default ##p!  @f bphase #! ; \ init bphase from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ ascale register ]----------------------------
\ 
\ ----- ascale 
[ config-block 15 + ] constant #f-ascale
-: save-ascale   #f-ascale ##p!  ascale #  fwrite-quad ;
\ -: @f-ascale  ( - lsb ... msb)   #f-ascale ##p!  fread-quad ;
-: /ad  ( @f-ascale)  #f-ascale ##p!  fread-quad ascale # !quad ;  \ init afreq from flash
\
\ ----- ascale defaults
\ -: ascale-def ;
here constant ascale-default
$d0 , $17 , $5c , $22 ,  \ 125 MHz clock, lsb written first
-: %ad  ascale-default ##p!  fread-quad  ascale # !quad ; \ init ascale from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ bscale register ]-----------------------------
\ 
\ ----- bscale
[ config-block 19 + ] constant #f-bscale
-: save-bscale   #f-bscale ##p!  bscale #  fwrite-quad ;
\ -: @f-bscale  ( - lsb ... msb)   #f-bscale ##p!  fread-quad ;
-: /bd  ( @f-bscale)  #f-bscale ##p!  fread-quad  bscale # !quad ;  \ init afreq from flash
\
\ ----- afreq defaults
\ -: bscale-def ;
here constant bscale-default
$d0 , $17 , $5c , $22 ,  \ 125 MHz clock, lsb written first
-: %bd  bscale-default ##p!  fread-quad  bscale # !quad ; \ init afreq from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ address register ]---------------------------
\ 
\ ----- adr
[ config-block 23 + ] constant #f-adr
-: save-adr   #f-adr ##p!  adr #@ !f ;
-: @f-adr  ( - n)   #f-adr ##p!  @f ;
-: /adr  @f-adr  adr #! ;  \ init adr from flash
\
\ ----- adr default
\ -: adr-def ;
here constant adr-default
$00 ,  \ global address
-: %adr  adr-default ##p!  @f  adr #! ; \ init adr from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ ------------------------[ open drain flag ]---------------------------
\ 
\ ----- od
[ config-block 24 + ] constant #f-od
-: save-od   #f-od ##p!  od? #@ !f ;
\ -: @f-od  ( - n)   #f-od ##p!  @f ;
-: /od  ( @f-od)  #f-od ##p!  @f  od? #! ;  \ init od flag from flash
\
\ ----- od default
\ -: od-def ;
here constant od-default
$ff ,  \ push-pull
-: %od  od-default ##p!  @f  od? #! ; \ init od from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ ---------------------------[ 9851 flag ]------------------------------
\ 
\ ----- 9851
[ config-block 25 + ] constant #f-9851
-: save-9851   #f-9851 ##p!  9851? #@ !f ;
-: /9851  #f-9851 ##p!  @f  9851? #! ;  \ init 9851 flag from flash
\
\ ----- 9851 default (9850)
\ -: 9851-def ;
here constant 9851-default
$00 ,  \ 9850
-: %9851  9851-default ##p!  @f  9851? #! ; \ init 9851 from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ ---------------------------[ emit? flag ]------------------------------
\ 
\ ----- emit?
[ config-block 26 + ] constant #f-emit?
-: save-emit?   #f-emit? ##p!  emit? #@ !f ;
-: /eflag  #f-emit? ##p!  @f  emit? #! ;  \ init emit? flag from flash
\
\ ----- emit? default (responsive)
\ -: emit?-def ;
here constant emit?-default
$ff ,  \ responsive
-: %eflag  emit?-default ##p!  @f  emit? #! ; \ init emit? from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ ------------------------------[ mask ]--------------------------------
\ 
\ ----- mask
[ config-block 27 + ] constant #f-mask
-: save-mask   #f-emit? ##p!  mask #@ !f ;
-: /lmask  #f-mask ##p!  @f  mask #! ;  \ init mask from flash
\ 
\ ----- mask default (listen)
\ -: mask-def ;
here constant mask-default
$ff ,  \ listen
-: %lmask  mask-default ##p!  @f  mask #! ; \ init mask from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ SL says that flash lasts longer with two erases before a write
-: !cfg  erase-config  erase-config  
   save-hold   ( save-phold)   save-afreq   save-aphase  
   save-bfreq  save-bphase  save-ascale  save-bscale  save-adr 
   save-od  save-9851  save-emit? ;
-: 0regs  0temp  0freq  0prod  0scale ;
-: (/cfg)  /hf  /ph  /af  /ap  /bf  /bp  /ad  /bd  /adr /od /9851 /eflag /lmask ;
-: (//)  %h   %ph  %af  %ap  %bf  %bp  %ad  %bd  %adr  %od  %9851 %eflag %lmask ;
\ if hold flash bytes are all $ff (cfg not saved), init from defaults 
-: /cfg   0regs  $ff # mask #!  $ff # gmask #! 
   @f-hold xor push xor pop ior 0=if drop (//) ; then drop (//) (/cfg) ;
\ 
here ( stop marker) [ swap -  cr .( configuration.fs   ) . .( bytes) ]
\ 
0 [if] \ ------------------------[ revisions ]---------------------------------
\ 
Date	By  Comment
=======	=== ===================================================================
24Jan13 rjn added listen mask
22Jan13 rjn added flag for conditional emit
20Jan13 rjn removed phold register (skipped over its byte)
26Sep12 rjn fixed incorrect references to "adr" for 9851? and od?
04Sep12 rjn eliminated header defs to reduce code size
03Sep12 rjn added adr register
31Aug12 rjn added conditional init for /cfg.  Also zeroed out volatile regs.
30Aug12 rjn added phase registers
16Aug12 rjn initial version
\ 
[then] \ ----------------------------------------------------------------------
