\ mide-standalone.fs -- mide command interpreter -- 17Sep13 rjn

0 [if]
Copyright (C) 2004-2006 by Charles Shattuck.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL information:   http://www.gnu.org/copyleft/lesser.txt

[then]
\ 
0 [if] \ -------------------------[ Notes ]------------------------------------
\ 
1. Bare bones version for programmer ( no ok, no number, no errs, etc.).
\ 
[then] \ ----------------------------------------------------------------------
] here
\ 
\ serial words are now loaded in job.fs file
\ : emit begin 1 .SCON until. 1 .SCON clr SBUF #! ;
\ : key  begin 0 .SCON until. 0 .SCON clr SBUF #@ ;
\ 
\ -: echo dup (emit) ;
\ -: space BL # (emit) ;
\ -: cr 13 # (emit) 10 # (emit) ;
\ 
2 constant tib  \ begins after S, and A.

\ -: ok      
\   tib  #@ 0=if drop ( emit>) ; then drop \ no entry, no error, normal prompt
   ( err? #@   if [ char ? ] # emit ) 
\      ( [ #errs inc ] then drop) ( emit>) ;
\ 
-: 2dup |over |over ;
-: min 2dup swap
-: clip negate + -if push swap pop then 2drop ;
-: max 2dup clip ;
-: p |p ;
-: @p |@p ;    
-: @p+ |@p+ ;  
\ 
\ -: depth [ SP0 -2 + ] # S #@ negate + ;
\ -: depth S #@ invert ;  \ in utils.fs
\ 
\ see job.fs to see how this is patched
-: huh?   here ( *) nop nop nop ;  constant patch-cold

\ debug version -- allow stack items
-: ?stack   depth -if huh? ; then drop  depth if drop ( huh?) ; then drop ;
\ -: ?stack  depth 0=if drop ; then huh? ; \ nothing on stack for this app.

-: match ( ? - ?) @+ @p+ xor ior ;  \ 0 if still a match.
-: word 0 # tib # a! match match match match ;
-: ?digit [ char 0 negate ] # + -if huh? then -10 # + +if huh? then 10 # + ;
\ 
-: find @p if drop word if drop p+ p+ find ; then invert ; then drop 0 # ;
\ 
here constant dict  \ Patch this later with real dictionary.
\ headers ] here [ dict org heads ##p! org ]  \ like this
\ 
-: dictionary 0 ##p! ;
-: interpret p push push a push dictionary find if
   drop @p+ @p pop a! pop pop p! push push ; then drop pop a! pop pop p! ;
-: tib! ( c) a push tib #@ 1+ tib #! tib # dup a! @ + 6 # min a! ! pop a! ;
-: 0tib tib # dup a! 0 # dup !+ dup !+ dup !+ dup !+ ! a! ;

0 [if] \ ----------------------------------------------------------------------
\ These are patched out because of special numeric processing for "#" and "$".
-: query 0tib
-: back key 8 # =if drop cr query ; then BL # max echo BL # xor if
   BL # xor tib! back ; then drop ;
-: quit query interpret ?stack ok quit ;
[then] \ ----------------------------------------------------------------------

-: $key  ( - c)   key  ( /err?)  tib #@  0=if drop ( ?num) ; then drop ;

true [if] \ ------------- modified interpreter for DDS ------------------------
-: query 0tib
-: back  
   $key 8 # =if drop ( ok) query ; then BL # max ( echo) BL # xor if
   BL # xor tib! back ; then drop ;
-: quit  ( ?complete)  query interpret ?stack ( ok) quit ;
[then] \ ----------------------------------------------------------------------

\ Standalone Notes by rjn:
\ 1. The "BL # max" in back allows up to 32 chars as the tib count.
\ 2. The "BL # xor if" terminates input on a blank.
\ 3. The "BL # xor tib!" gets the char if it isn't a blank and puts
\    in the tib, updating the count in the first cell of tib ( i.e., tib).
\ 4. Each dictionary entry takes 6 bytes (cnt, 3 chars, 2 adr).

 here  [ swap -  ( -- n)
 cs? [if] cr .( mide-standalone    ) . .( bytes)  [else] drop [then]
 ]
 \    
\ 
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	   By  Comment
=======	=== ===================================================================
17Sep13  rjn cleanup for final version of mide.
10Aug13  rjn added conditional compilation summary (originally cloned from DCON)
\
[then] \ ----------------------------------------------------------------------


